from unittest import TestCase
from solvers import solve_linear_equation


class SolversTest(TestCase):

    def test_solves_general_linear_equation(self):
        """Checks solution for k = 2 and d = 5."""
        result = solve_linear_equation(k=2., d=5.)
        self.assertAlmostEqual(result, -2.5)

    def test_throws_for_gradient_zero(self):
        """Solve throws exception for gradient zero."""
        with self.assertRaises(ZeroDivisionError):
            solve_linear_equation(k=0, d=5)
