from unittest import TestCase
from solvers import solve_linear_equation


class SolversTest(TestCase):

    def setUp(self):
        self.nonzero_gradient = 2.
        self.nonzero_offset = 5.

    def test_solves_general_linear_equation(self):
        """Checks solution for nonzero gradient, offset."""
        result = solve_linear_equation(self.nonzero_gradient,
                                       self.nonzero_offset)

        self.assertAlmostEqual(result, -2.5)

    def test_throws_for_gradient_zero(self):
        """Solve throws exception for gradient zero."""
        with self.assertRaises(ZeroDivisionError):
            solve_linear_equation(k=0,
                                  d=self.nonzero_offset)
