import matplotlib.pyplot as plt
import numpy as np

x = np.linspace(0, 5, 50)

y1 = np.zeros_like(x)
y1[x < 1] = np.exp(x[x<1] / 2)
y1[x >= 1] = 1.7 * np.exp(-(x[x>=1] - 1) ** 2 / 4)

def smooth(v):
    return (v[1:] + v[:-1]) / 2

y1 = smooth(smooth(y1))
y1 = smooth(smooth(y1))
y1 = smooth(smooth(y1))
y1 = smooth(smooth(y1))

y2 = np.zeros_like(x)
y2[x < 2] = np.exp(x[x<2] / 4) * .8
y2[x >= 2] = 1.3 * np.exp(-(x[x>=2] - 2) ** 1.7 / 14)

y2 = smooth(smooth(y2))
y2 = smooth(smooth(y2))
y2 = smooth(smooth(y2))
y2 = smooth(smooth(y2))

plt.xkcd()
plt.plot(x[:-8], y1, label="beginner")
plt.plot(x[:-8], y2, label="professional")
# plt.plot(x, y2)
plt.legend()
plt.title("programming speed over time")
plt.savefig("time.png")
